## SHAP机器学习模型解释库
想象一下，你正试图训练一个机器学习模型来预测广告是否被特定的人点击。在收到关于某人的一些信息后，模型预测某人不会点击广告。

![](img/图1.png)

但是为什么模型会输出这样的预测结果呢？ 每个特征对预测的贡献有多大？ 如果您能看到一个图表，显示每个特征对预测的贡献程度，如下所示，不是很好吗？

![](img/权重.png)

Shapley值就能起到特征权重测度的作用。

## Shapley值是什么？
Shapley值是博弈论中使用的一种方法，它涉及公平地将收益和成本分配给在联盟中工作的行动者。
由于每个行动者对联盟的贡献是不同的，Shapley值保证每个行动者根据贡献的多少获得公平的份额。
![](img/贡献.png)

## 小案例
Shapley值被广泛地应用于求解群体中每个工人(特征)的贡献问题。要理解Shapley值的作用，让我们想象一下贵公司刚刚做了A/B测试，他们在测试广告策略的不同组合。

每个策略在特定月份的收入是：
- 无广告：150美元
- 社交媒体：300美元
- 谷歌广告：200美元
- 电子邮件营销：350美元
- 社交媒体和谷歌广告：320美元
- 社交媒体和电子邮件营销：400美元
- 谷歌广告和电子邮件营销：350美元
- 电子邮件营销，谷歌广告和社交媒体：450美元

![](img/策略营收.png)

使用三则广告与不使用广告的收入相差300美元，每则广告对这一差异有多大的贡献?

![](img/策略营收贡献几何.png)

我们可以通过计算每一类广告的Shapley值来计算谷歌广告对公司收入的总贡献入手，通过公式可以计算出Google广告的总贡献：

![](img/公式.png)

让我们找到Google广告的边际贡献及其权重。

## 寻找谷歌广告的边际贡献
第一，我们将发现谷歌广告对以下群体的边际贡献：
- 无广告
- 谷歌广告+社交媒体
- 谷歌广告+电子邮件营销
- 谷歌广告+电子邮件营销+社交媒体

![](img/边际贡献.png)

Google广告 对 无广告 的边际贡献是：

![](img/MC1.png)

谷歌广告 对 谷歌广告&社交媒体组合 的边际贡献是：

![](img/MC2.png)

谷歌广告 对 谷歌广告&电子邮件营销组合 的边际贡献是：

![](img/MC3.png)

谷歌广告 对 谷歌广告、电子邮件营销和社交媒体组合 的边际贡献是：

![](img/MC4.png)

## 发现权重
为了发现权重，我们将把不同广告策略的组合组织成如下多个层次，每个层次对应于每个组合中广告策略的数量。

然后根据每个层次的边数分配权重，我们看到了这一点：
- 第一级包含3条边，因此每个边的权重为1/3
- 第二级包含6条边，因此每条边的权重将为1/6
- 第三级包含3条边，因此每条边的权重将为1/3

![](img/发现权重.png)

## 发现Google广告的总贡献
根据前面的权重和边际贡献，我们已经可以找到Google广告的总贡献!

![](img/google总贡献.png)


![](img/google公式.png)

酷!所以谷歌广告在使用3种广告策略与不使用广告的总收入差异中贡献了36.67美元。36.67是Google广告的Shapey值。

![](img/otherRevenue.png)

重复以上步骤，对于另外两种广告策略，我们可以看出：
- 电子邮件营销贡献151.67美元
- 社交媒体贡献116.67美元
- 谷歌广告贡献36.67美元

![](img/各策略贡献.png)

他们共同出资300美元，用于使用3种不同类型的广告与不使用广告的区别!挺酷的，不是吗?
既然我们理解了Shapley值，那么让我们看看如何使用它来解释机器学习模型。